#include <iostream>

using namespace std;

int main()
{
    long long int p[200050], n, k, a, c, x, imax, r=1;
    long long s=0, smax=0, sa=0;
    bool t=true, tt=true;
    cin >> n >> k >> x;
    for(int i=0; i<n; i++)
        cin >> p[i];
    //ok sta ja sad s to da radim
    if(x==2)
    {
        for(int i=0; i<n-k+1; i++)
        {
            c=1;
            a=0;
            for(int j=k+i-1; j>i; j--)
            {
                s+=p[j];
                if(s>smax)
                {
                    smax=s;
                }
            }
            cout << s+p[i]+smax << " ";
            s=0;
            smax=0;
        }
    }
    for(int i=0;i<n;i++)
    {
        if(p[i]<0)
            t=false;
    }
    if(t)
    {
        for(int i=0; i<k; i++)
        {

            s+=p[i]*r;
            if(r<x)
            {
                r++;
                sa+=p[i];
            }
        }
        sa+=p[x-1];

        cout << s << " ";
        for(int i=1; i<n-k+1; i++)
        {
            s=s-sa+x*p[k+i-1];
            sa=sa-p[i-1]+p[k+i+1-x];
            cout << s <<" ";
        }
    }




    /*for(int i=0; i<n; i++)
    {
        c=1;
        a=0;
        for(int j=i; j<k+i; j++)
        {
            if(a[j+1]>0)
            {

            }
        }


        6 4 3
        1 2 4 6 7 5
    }*/
    return 0;
}
/**
Sta da radim ja
kada mi neko
banuje Jasua
I zato
sto si uradio to
sada ce
te suportovati Teemo

Banovase Jasua
uneli mi dramu
zb

al ne kao fr sta radim ja ovde kako sam ja ovde zavrsio uopste mislim da je to tipa skroz validno piranje
i zasto vasa litteraly aura farmuje (praying_hands)

ne mogu bre ja vise ovako sto ja sedim ovde
ladno mi je iz nekog razloga sunce hoce da me ubije povraca mi se umrecu uskoro vrv sta je ovo vise sta ovo treba da znaci

ne znam zapravo sto i dalje sedim ovde al mene stvarno infinitley(ta rec se ne pise tako) mrzi da radim ove stvari

sto se kaze ti imas gomilu tih nekih malih koji se trkaju, znas koje su sanse da se ti rodis, abnormalno male

e isto rodjendani su social construct to mozda nisam reko

jos jedan note ja cu da poludim mnogo je teze da drzimglavu uspravno nego da se kao covek naslonim na klupu i soavam msm stvarno kakvo je ovo ponasanje i bad design

tipa zadnjih 20 minuta mislim da nisam ni pomislio ni na jedan zadatak sto ja sedim ovde

postojanje teorije brojeva implicira postjanje prakse brojeva

testing pending
na luk stavljas infinity
a na drugo mending

ja kradem bakar i
mnogo mi lepo kada ga ukradem

pise debug in asfas (crying)
kao as fast
ali kao brze
asfas
treba mi profesionalna pomoc

isto lowkirkenuenly je
kao
to nije rec
ne znam
ne secam se sta ne znam

STA TO PADA PA DA VLA DA
idk iskreno
jos tri minuta do toga da ostane jos sat vremena
ovo je tipa najduzih i najkracih 3h mog zivota

gledao sam mindlesly u ovaj red
for(int i=1; i<n-k+1; i++)
i tolko mi vid nije bo fokusiran na bilo sta da sam samo vido for(int i=1)
i bio sam kao huh?????
moje dusevno stanje je poput lazanje (thumbs_up)

ja moram da pijem da zaboravim ja ne smem trezan tu da boravim
ja moram a ne to je isti line pa nema to da pisem??

e officially jos 58 minuta(sto je manje od 60(sto je jedan sat)) to je kidalica

a da da hos, joss, jots, jogs, josh, jobs, joys, sos, nos, jot, cos, dos

jel postojanje Wunused variable implicira postojanje Lunused variable???
food for thought(to vrv nije tacan spelling ali mislim da je to najmanji problem at this point)

e evo radio sam nesto ide gas na max nike ne adidas
*/